Home | History | Annotate | Download | only in move
      1 #!/bin/bash
      2 
      3 #
      4 # Copyright (c) International Business Machines  Corp., 2005
      5 # Author: Avantika Mathur (mathurav (at] us.ibm.com)
      6 #
      7 # This library is free software; you can redistribute it and/or
      8 # modify it under the terms of the GNU Lesser General Public
      9 # License as published by the Free Software Foundation; either
     10 # version 2.1 of the License, or (at your option) any later version.
     11 #
     12 # This library is distributed in the hope that it will be useful,
     13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
     14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     15 # Lesser General Public License for more details.
     16 #
     17 # You should have received a copy of the GNU Lesser General Public
     18 # License along with this library; if not, write to the Free Software
     19 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
     20 #
     21 
     22 SETS_DEFAULTS="${TCID=test07} ${TST_COUNT=1} ${TST_TOTAL=1}"
     23 declare -r TCID
     24 declare -r TST_COUNT
     25 declare -r TST_TOTAL
     26 export TCID TST_COUNT TST_TOTAL
     27 
     28 tst_resm TINFO "***************TEST07***************"
     29 tst_resm TINFO "move: private subtree to slave parent."
     30 tst_resm TINFO "************************************"
     31 
     32 . "${FS_BIND_ROOT}/bin/setup" || (tst_resm TWARN "Setup of move/test07 failed" && tst_exit)
     33 export result=0
     34 
     35 
     36 
     37 trap 'ERR=$? ; ERR_MSG="caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"; break' ERR
     38 
     39 while /bin/true ; do
     40 	# This loop is for error recovery purposes only
     41 
     42 
     43 	"${FS_BIND_ROOT}/bin/makedir" priv dir
     44 	"${FS_BIND_ROOT}/bin/makedir" share parent2
     45 	"${FS_BIND_ROOT}/bin/makedir" share share2
     46 	"${FS_BIND_ROOT}/bin/makedir" share share1
     47 
     48 	mkdir dir/grandchild
     49 	mount --bind dir share1
     50 	mkdir parent2/child2
     51 	mount --bind parent2 share2
     52 	"${FS_BIND_ROOT}/bin/makedir" slave parent2
     53 	mount --move dir parent2/child2
     54 
     55 	mount --bind "$disk1" parent2/child2/grandchild
     56 	check -n parent2/child2/grandchild share2/child2/grandchild
     57 	check -n dir/grandchild parent2/child2/grandchild
     58 	check -n share1/grandchild parent2/child2/grandchild
     59 
     60 	break
     61 done
     62 trap 'ERR=$? ; tst_resm TWARN "move/test07: caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"' ERR
     63 if [ -n "${ERR_MSG}" ]; then
     64 	tst_resm TWARN "move/test07: ${ERR_MSG}"
     65 	ERR_MSG=""
     66 	result=$ERR
     67 fi
     68 trap '' ERR
     69 {
     70 	umount parent2/child2/grandchild
     71 	umount parent2/child2 # if move succeeded
     72 	umount dir # if move did not succeed
     73 	umount share2
     74 	umount share1
     75 	umount share1
     76 	umount share2
     77 	umount parent2
     78 	umount dir
     79 
     80 	rm -rf dir parent* share*
     81 	cleanup
     82 } >& /dev/null
     83 if [ $result -ne 0 ]
     84 then
     85 	tst_resm TFAIL "move/test07: FAILED: move: private subtree to slave parent."
     86 	exit 1
     87 else
     88 	tst_resm TPASS "move/test07: PASSED"
     89 	exit 0
     90 fi
     91 tst_exit
     92